=== debian/changelog ===
dccserver (0.2-1) unstable; urgency=low

  * New upstream release  
  * Upstream removed snprintf, license changed

 -- Aubin Paul <debian@outlyer.org>  Wed, 22 Jan 2003 12:47:06 -0500

dccserver (0.1-1) unstable; urgency=low

  * Initial Release.

 -- Aubin Paul <debian@outlyer.org>  Wed, 16 Oct 2002 19:16:09 -0400
