=== debian/control ===
Source: dccserver
Section: net
Priority: optional
Maintainer: Aubin Paul <debian@outlyer.org>
Build-Depends: debhelper (>> 3.0.0)
Standards-Version: 3.5.2

Package: dccserver
Architecture: any
Depends: ${shlibs:Depends}
Description: A UN*X equivalent for mIRC's /dccserver command
 dccserver aims to provide the functions of mIRC's /dccserver command. 
 Currently, Chat and Send (including resume) modes are supported. Fserve 
 and Get mode are not yet supported.
